-- error.e
-- Error display dialog for eBasic

without warning
without trace
without type_check

include dialog.e
include graphics.e

global integer abortLine
global sequence abortCode
    abortLine = 0
    abortCode = {}


-----------------------------------------------------------------------------
global procedure set_text_mode()

    object x
    
    -- check current video mode
    x = video_config()
    if x[VC_MODE] != 3 then  
        -- restore to default graphics mode
        x = graphics_mode(3)
    end if

    -- default colors
    text_color( WHITE )
    bk_color( BLACK )

end procedure


-----------------------------------------------------------------------------
-- save screen
set_text_mode()
constant
    SCREEN_IMAGE    = save_text_image( {1,1}, {25,80} ),
    SCREEN_POSITION = get_position()


-----------------------------------------------------------------------------
global procedure abort_error( sequence title, sequence msg )

    -- display error, and abort
    
    object x
    
    -- restore text mode
    set_text_mode()
    
    -- display error
    x = msgbox( OK, title, msg )

    -- restore colors, clear screen
    text_color( WHITE )
    bk_color( BLACK )

    -- restore the screen
    display_text_image( {1,1}, SCREEN_IMAGE )
    position( SCREEN_POSITION[1], SCREEN_POSITION[2] )

    -- display message again, with line number
    puts( 1, "\n" )
    
    -- line number and text
    if abortLine > 0 then
        printf( 1, "Error on line %d.\n", {abortLine} )
        puts( 1, title & ":\n" )
        puts( 1, abortCode )
    end if
    
    puts( 1, msg & "\n" )
    
    -- abort
    abort( 0 )
    
end procedure

